package tp4509.tcp;

import tp4509.picross.PicrossApi;


/**
 * Interface qui définit la méthode à lancer lors de la réception d'un message du protocole.
 * @author Eric Lallet.
 *
 */
@FunctionalInterface
public interface ProtocoleAction {
	/**
	 * La méthode à lancer lors de la réception d'un message du protocole.
	 * @param picrossApi
	 *        réference vers la classe qui gére les données du jeu.
	 * @param val1
	 *        premier paramètre du message du protocole.
	 * @param val2
	 * 	      deuxième paramètre du message du protocole.
	 * @param val3
	 *        troisème paramètre du message du protocole.
	 */
	void realiser(PicrossApi picrossApi, int val1, int val2, int val3);

}
