//CHECKSTYLE:OFF
package tp4509.tcp;

import static dm4509.common.Log.LOGGER_NAME_TEST;
import static dm4509.common.Log.LOGGER_NAME_COMM;
import static dm4509.common.Log.LOG_ON;
import static dm4509.common.Log.COMM;
import static dm4509.common.Log.TEST;
import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;


import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.nio.channels.ServerSocketChannel;
import java.nio.channels.SocketChannel;

import org.apache.log4j.Level;
import org.junit.AfterClass;
import org.junit.BeforeClass;
import org.junit.Ignore;
import org.junit.Test;


import dm4509.common.Log;


public class TestServeurPicross {


	@BeforeClass
	static public void lanceTestTools() throws InterruptedException {
		Log.configureALogger(LOGGER_NAME_TEST, Level.TRACE);
		Log.configureALogger(LOGGER_NAME_COMM, Level.INFO);
		if (LOG_ON && TEST.isInfoEnabled()) {
			TEST.info("[TestServeurPicross] ----------- Début des tests unitaires pour la classe ServeurPicross -----------");
		}
	}
	
	@AfterClass
	static public void finTest() throws InterruptedException {
		if (LOG_ON && TEST.isInfoEnabled()) {
			TEST.info("[TestServeurPicross] ----------- Fin des tests unitaires pour la classe ServeurPicross -----------\n");
		}
	}

	//@Ignore
	@Test
	public void testCreateServerSocket() throws Exception {

		if (LOG_ON && TEST.isInfoEnabled()) {
			TEST.info("[TestServeurPicross::testCreateServerSocket] ->  test de création d'un serveur assynchrone");
		}

		ServerSocketChannel listenChan = ServeurPicross.createServerSocket(40001);
		
		if (LOG_ON && TEST.isEnabledFor(Level.TRACE)) {
			TEST.trace("[TestServeurPicross::testCreateServerSocket] -> le canal est assynchrone ?" + !listenChan.isBlocking());
		}
		assertFalse("Le canal est assynchrone.", listenChan.isBlocking());
		
		
		InetSocketAddress rcvAddress = new InetSocketAddress(InetAddress.getByName("localhost"), 40001);
		SocketChannel rwChan =  SocketChannel.open(rcvAddress);
		if (LOG_ON && TEST.isEnabledFor(Level.TRACE)) {
			TEST.trace("[TestServeurPicross::testCreateServerSocket] -> le canal écoute ?" + rwChan != null);
		}
		
		assertTrue("La connexio a réussi", rwChan != null);
		
		rwChan.close();
		listenChan.close();
		if (LOG_ON && TEST.isInfoEnabled()) {
			TEST.info("[TestServeurPicross::testCreateServerSocket] -> Fin du test");
		}

	
	}

	


}
